﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Excel = Microsoft.Office.Interop.Excel;
using Office = Microsoft.Office.Core;
using Microsoft.Office.Tools.Excel;
using Microsoft.Office.Tools;
using org.apache.hadoop.hbase;
using org.apache.hadoop.hbase.client;
using org.apache.hadoop.conf;
using java.util;
using org.apache.hadoop.hbase.io;
using org.apache.hadoop.hbase.util;

namespace HBaseExcelAddIn
{
    public static class MapReduce
    {
        public static int executeMapReduce(Excel.Range navigator
            , string columnToFilter
            , string filterValue
            , string frequencyColumn
            , string hostName
            , string tableName)
        {

            string rowKey;
            int count;
            int currentRow = 1;
            int currentColumn = 1;
            Excel.Range currentCell;

            try
            {
                HBaseToLinq.FrequencyMapRed.executeMapRed(hostName, tableName, frequencyColumn, columnToFilter, filterValue);
            }
            catch(Exception ex)
            {
                throw ex;
            }

            Configuration hbaseConfig = HBaseConfiguration.create();
            hbaseConfig.set("hbase.zookeeper.quorum", hostName);
            try
            {
                string cellName =  frequencyColumn.Substring(frequencyColumn.IndexOf(":") + 1);
                string familyName = frequencyColumn.Substring(0, frequencyColumn.IndexOf(":"));
                HTable tbl = new HTable(hbaseConfig, "summary_user");
                Scan scan = new Scan();
                ResultScanner scanner = tbl.getScanner(scan);
                Result r;
                while ((r = scanner.next()) != null)
                {
                    rowKey = Bytes.toString(r.getRow());
                    count = Bytes.toInt(r.getValue(Bytes.toBytes(familyName), Bytes.toBytes("total")));
                    currentCell = navigator.Cells[currentRow, currentColumn++];
                    currentCell.Value2 = rowKey;
                    currentCell = navigator.Cells[currentRow++, currentColumn];
                    currentCell.Value2 = count;
                    currentColumn = 1;
                }
                scanner.close();
                tbl.close();
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return currentRow - 1;
        }
    }
}
